/*
 * misc.h - generated by updprotos
 */
#ifndef _misc_h
# define _misc_h

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#include <sys/cdefs.h>
#include <stdio.h>
#include <string.h>

#if defined(_ANSI_SOURCE) || defined(_POSIX_SOURCE)
/* many systems omit these if the above defined */
char    *strdup __P((const char *));
#endif

#if defined(HAVE_DMALLOC_H) && defined(USE_DMALLOC)
# include "dmalloc.h"
#else
# ifdef HAVE_MALLOC_H
#   include "malloc.h"
# endif
#endif

#define ALLOCADUP(s) strcpy(alloca(strlen(s) + 1), (s))

#include "sjg/dlist.h"
#include "sjg/vars.h"

extern int errno;
extern int SyslogOpen;
extern int SyslogPri;

#endif	/* _misc_h */

__BEGIN_DECLS
/*
 * These were added by updprotos, don't bother editing by hand
 */
int 	atexit	 __P((void (*)(void)));
const char *	basename	 __P((const char *));
char *	chop	 __P((char *));
int 	upd_ent	 __P((char *, char *, char *));
int 	get_ent	 __P((char *, char *, char *, int ));
char *	EscapeE	 __P((char *, const unsigned char *, size_t , const char *, const char *));
char *	Escape	 __P((unsigned char *, const char *, size_t ));
char *	UnEscapeE	 __P((char *, const unsigned char *, size_t , const char *, const char *));
char *	UnEscape	 __P((char *, const unsigned char *, size_t , const char *));
void 	fatal	 __P((const char *, ...));
int 	error	 __P((const char *, ...));
void 	die	 __P((int , const char *, ...));
int 	upd_ent	 __P((char *, char *, char *));
int 	get_ent	 __P((char *, char *, char *, int ));
unsigned long 	hash_perl __P((unsigned const char *, int, int ));
unsigned long 	HashM	 __P((const char *, int, int ));
unsigned long 	HashN	 __P((const char *, int ));
unsigned long 	Hash	 __P((const char *));
void setHashFunc __P((int));
char *	sprint_hex	 __P((char *, unsigned char *, int , int ));
char *	shex_dump	 __P((char *, unsigned char *, int ));
int 	fprint_hex	 __P((FILE *, register unsigned char *, register int , int ));
void 	fhex_dump	 __P((FILE *, register unsigned char *, register int ));
int 	print_hex	 __P((register unsigned char *, register int , int ));
void 	hex_dump	 __P((register unsigned char *, register int ));
int 	IsFieldVal	 __P((const char *, const char *));
int 	isipaddr	 __P((char *));
char *	itoa	 __P((int , int ));
int 	lockdb	 __P((char *, char *, int ));
int 	unlockdb	 __P((char *, int ));
int 	logfacs	 __P((const char *));
int 	pencode	 __P((const char *));
char *	escape	 __P((unsigned char *, const char *, size_t ));
char *	un_escape	 __P((char *, const unsigned char *, size_t , const char *));
FILE *	popen	 __P((const char *, const char *));
int 	pclose	 __P((FILE *));
int 	process_file	 __P((int (*)(), char *));
int     process_header   __P((const char * /*line*/));
void    set_field        __P((const char * /*name*/, int  /*num*/));
int     field_num        __P((const char * /*name*/));
const char *    field_name       __P((int  /*num*/));
char ** s2argvb  __P((char * /*line*/, const char * /*toks*/, int  /*base*/, int * /*acp*/));
char ** s2argv   __P((char * /*line*/, const char * /*toks*/, int * /*acp*/));
char ** s2avb  __P((char * /*line*/, const char * /*toks*/, int  /*base*/, int * /*acp*/));
char ** s2av   __P((char * /*line*/, const char * /*toks*/, int * /*acp*/));
int     process_records  __P((int (*/*func*/)(), char * /*file*/));
char *	rot13	 __P((char *));
int 	shstr	 __P((char *, char *, int ));
DList *	str2dlist	 __P((char *, const char *, void *(*)(void *)));
char *	__strerror	 __P((int , char *));
char *	strerror	 __P((int ));
char *	Strtok	 __P((char *, const char *));
char *	SkipWs	 __P((char *));
char *	TrimWs	 __P((char *));
char *	SkipEmptyLines	 __P((char *));
char *	LoseChar	 __P((const char *, int ));
char *	LoseChars	 __P((const char *, const char *));
/* fmatch.c */
char *  find_match       __P((const char *, int));
/* chat.c */
char ** get_chat         __P((const char *));
int     save_chat        __P((const char *, char *));
int     show_chat        __P((const char *));
int     load_chats       __P((const char *));
void    add_builtin      __P((char *, int (*)()));
int (*  get_builtin      __P((char *)))();
int     chat_special     __P((char **, int *, int (*)(), int (*)(), int (*)()));
int     chat     __P((const char *, int (*)(), int (*)(), int (*)()));
int     app_checkpoint   __P((int  /* ival */));
int     app_init         __P((int  /* argc */, char ** /* argv */, char * /* extras */, int (*/* optfunc */)()));
void    batchin_init     __P((const char * /* list */, const char * /* disp */, int (*/* checkpoint */)(void *), void * /* checkpoint_arg */));
const char *    batchin_next     __P((int  /* timeout */));
FILE * batchin_fp       __P((int  /* timeout */));
FILE * batchin_stdin    __P((int  /* timeout */));
void   batchin_done    __P((void));
/*exists.c*/
int     Exists   __P((const char * /*file*/));
/*evfile.c*/
int     eval_file        __P((char * /*file*/));
/*shstr.c*/
int     shstr    __P((char * /*cmd*/, char * /*buf*/, int  /*nbytes*/));
/*struplwr.c*/
char *  struplwr         __P((char * /*s*/, int  /*up*/));
char *  strlower         __P((char * /*s*/));
char *  strupper         __P((char * /*s*/));
/*noedit.c*/
int 	DoNotEdit	 __P((FILE * /*fp*/, const char * /*id*/, const char * /*lang*/));
/*runChild.c*/
int 	setChildAv	 __P((char * /*cmd*/, int  /*nargs*/));
void 	reapChildren	 __P((void));
void 	runChildAv	 __P((char * /*cmd*/, int  /*nargs*/, char * /*args*/[], int  /*async*/));
void 	runChild	 __P((char * /*cmd*/, char * /*arg*/, int  /*async*/));


__END_DECLS
